/*_ ctype.h   Fri Apr 28 1989   Modified by: Walter Bright */

#ifndef __CTYPE_H
#define __CTYPE_H	1

#if __cplusplus
extern "C" {
#endif

#ifdef __STDC__
#define __CDECL
#define __STDCALL
#else
#define __CDECL __cdecl
#define __STDCALL __stdcall
#endif

#if __OS2__ && __INTSIZE == 4
#define __CLIB	__STDCALL
#else
#define __CLIB	__CDECL
#endif

#define _SPC	8	/* white space		*/
#define _CTL	0x20	/* control char		*/
#define _BLK	0x40	/* ' '			*/
#define _HEX	0x80	/* hex digit		*/
#define _UC	1	/* upper case letter	*/
#define _LC	2	/* lower case letter	*/
#define _PNC	0x10	/* punctuation		*/
#define _DIG	4	/* dig			*/

extern const char __CLIB _ctype[];
typedef unsigned short wchar_t;

int	__CLIB isalnum(int);
int	__CLIB isalpha(int);
int	__CLIB iscntrl(int);
int	__CLIB isdigit(int);
int	__CLIB isgraph(int);
int	__CLIB islower(int);
int	__CLIB isprint(int);
int	__CLIB ispunct(int);
int	__CLIB isspace(int);
int	__CLIB isupper(int);
int	__CLIB isxdigit(int);
int	__CLIB toupper(int);
int	__CLIB tolower(int);

#define isalnum(c)	(_ctype[(c)+1]&(_UC|_LC|_DIG))
#define isalpha(c)	(_ctype[(c)+1]&(_UC|_LC))
#define iscntrl(c)	(_ctype[(c)+1]&_CTL)
#define isdigit(c)	(_ctype[(c)+1]&_DIG)
#define isgraph(c)	(_ctype[(c)+1]&(_UC|_LC|_DIG|_PNC))
#define islower(c)	(_ctype[(c)+1]&_LC)
#define isprint(c)	(_ctype[(c)+1]&(_UC|_LC|_DIG|_PNC|_BLK))
#define ispunct(c)	(_ctype[(c)+1]&_PNC)
#define isspace(c)	(_ctype[(c)+1]&_SPC)
#define isupper(c)	(_ctype[(c)+1]&_UC)
#define isxdigit(c)	(_ctype[(c)+1]&_HEX)

#define _tolower		tolower
#define _toupper		toupper
#ifndef __STDC__

#define isascii(c)	((unsigned)(c)<0200)
#define __isascii(c)	((unsigned)(c)<0200)
#define toascii(c)	((c)&0x7F)
#define __toascii(c)	((c)&0x7F)

#endif

#if __cplusplus
}
#endif

#endif /* __CTYPE_H */
