/*_ process.h   Tue May 29 1990   Modified by: Walter Bright */
/* OS2 support added by Nikki Locke May 1989 */
/* Copyright (C) 1988-1990 by Walter Bright	*/
/* All Rights Reserved					*/
/* Written by Walter Bright				*/

#if __cplusplus
extern "C" {
#endif

#ifdef __STDC__
#define __CDECL
#define __STDCALL
#else
#define __CDECL __cdecl
#define __STDCALL __stdcall
#endif

#if __OS2__ && __INTSIZE == 4
#define __CLIB	__STDCALL
#else
#define __CLIB	__CDECL
#endif

#ifdef _WINDOWS
          void __CLIB exec_showset(unsigned short style); /* set client window SHOW style used be spawn, system, etc. */
          void __CLIB exec_showreset(void);		 /* reset SHOW style to default (SW_SHOW) */
unsigned short __CLIB exec_showget(void);		 /* get current SHOW style setting */
#endif

void __CLIB _c_exit(void);
void __CLIB _cexit(void);
void __CLIB _exit(int);
void __CLIB _dodtors(void);
int __CLIB getpid(void);
#define _getpid getpid

int __CDECL spawnl(int,const char *,const char *,...);
int __CLIB spawnv(int,const char *,const char * const *);
int __CDECL spawnlp(int,const char *,const char *,...);
int __CLIB spawnvp(int,const char *,const char * const *);

#define _spawnl spawnl
#define _spawnv spawnv
#define _spawnlp spawnlp
#define _spawnvp spawnvp

/* mode values for spawn?? */
#define P_WAIT 0
#define P_NOWAIT 1
#define P_SAVEEXIT 2
#define P_DETACHED 4

int __CLIB execl(const char *,const char *,...);
int __CLIB execv(const char *,const char * const *);
int __CLIB execlp(const char *,const char *,...);
int __CLIB execvp(const char *,const char * const *);
#define _execl execl
#define _execv execv
#define _execlp execlp
#define _execvp execvp

#if defined(M_UNIX) || defined(M_XENIX)
int __CLIB fork(void);
int __CLIB execle(const char *path,const char *arg1,...);
int __CLIB execve(const char *command, const char *command_line[],
                  const char *environment[]);
#endif

/* action codes used with cwait() */

#define WAIT_CHILD 0
#define WAIT_GRANDCHILD 1

int __CLIB cwait(int *,int,int);
int __CLIB wait(int *);

#ifdef _MT
#if __NT__

int __CLIB _beginthread(void (__CLIB *)(void *),unsigned,void *);
void __CLIB _endthread(void);

#elif __INTSIZE == 4

int __CLIB _beginthread(void (__CLIB *)(void *),unsigned,void *);
void __CLIB _endthread(void);

#else
int __CLIB _beginthread(void (__far *)(void __far *),
	void __far *, unsigned,void __far *);
void __CLIB _endthread(void);

#endif
#endif

#ifdef __cplusplus
  }
#endif


